function R = roundX(X, tol)

% Rounding postprocessing step for clustering with SDP.
% Sets all entries significantly less than diagonal equal to 0, o/w 1.


% Get dimensions of X.
n = length(X);

m = mean(diag(X));

% Initialize R.
R = zeros(n);

% Round entries of R.
for i =1:n
    for j = i:n
        %R(i,j) = ceil(X(i,j) - tol*max(X(i,i), X(j,j)));
        %R(i,j) = ceil(X(i,j) - tol*X(i,i));
        R(i,j) = ceil( X(i,j) - tol*(X(i,i) + X(j,j))/2);
        R(j,i) = R(i,j);
    end    
    
    % Cull outliers.
   if sum(R(:,i)) == 1
       R(:,i) = 0;
       R(i,:) = 0;
   end
end

