function [G, X0] = planted_kdb(m, n, p,q)

k = length(m);
M = sum(m);
N = sum(n);

m_beg = ones(k,1); % Initialize positions of start point of each planted clique.
n_beg = ones(k,1); % Initialize positions of start point of each planted clique.

% Set positions.
for i=2:k+1
    % Position is last position plus size of last clique.
    n_beg(i) = n_beg(i-1) + n(i-1); 
    m_beg(i) = m_beg(i-1) + m(i-1); 
end


%% Insert edges for planted dense subgraphs.

X0 = zeros(M, N); % Initialize X0.

% Make noise blocks.,
G = ceil(rand(M,N) - (1-p));

% Make dense blocks
for i=1:k
% Get G.

temp = rand(m(i), n(i));
    
G(m_beg(i):(m_beg(i+1)-1), n_beg(i):(n_beg(i+1)-1)) = ceil(temp - q);

% Get X0
X0(m_beg(i):(m_beg(i+1)-1), n_beg(i):(n_beg(i+1)-1)) = 1/sqrt(m(i)*n(i))*ones(m(i), n(i));
end

