function [G, X0,k] = planted_kdc(n, p,q)

k = length(n);
N = sum(n);

n_beg = ones(k,1); % Initialize positions of start point of each planted clique.

% Set positions.
for i=2:k+1
    % Position is last position plus size of last clique.
    n_beg(i) = n_beg(i-1) + n(i-1); 
end


%% Insert edges for planted dense subgraphs.

X0 = zeros(N); % Initialize X0.

% Make noise blocks.,
G = rand(N); G = (G + G')/2;
G = ceil(G - (1-p));

% Make dense blocks
for i=1:k
% Get G.

temp = rand(n(i)); temp = (temp + temp')/2;
    
G(n_beg(i):(n_beg(i+1)-1), n_beg(i):(n_beg(i+1)-1)) = ceil(temp - q);

% Get X0
X0(n_beg(i):(n_beg(i+1)-1), n_beg(i):(n_beg(i+1)-1)) = 1/n(i)*ones(n(i));
end

